/*
 * ${license.title}
 * Copyright (C) 2022 ${license.owner}
 * ${license.mailto}
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

//
// Created by webpigeon on 24/04/22.
//

#ifndef FGGL_PHYS_TYPES_HPP
#define FGGL_PHYS_TYPES_HPP

namespace fggl::phys {
	constexpr float STATIC_MASS = 0.0F;

	struct RigidBody {
		constexpr static const char* name = "phys::Body";
		float mass = 1.0F;
	};

	class PhysicsEngine {
		public:
			PhysicsEngine() = default;
			virtual ~PhysicsEngine() = default;

			// no copy and no move
			PhysicsEngine(PhysicsEngine&) = delete;
			PhysicsEngine(PhysicsEngine&&) = delete;
			PhysicsEngine& operator=(PhysicsEngine&) = delete;
			PhysicsEngine& operator=(PhysicsEngine&&) = delete;

			virtual void step() = 0;
	};

} // namespace fggl::phys

#endif //FGGL_PHYS_TYPES_HPP
